
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  PaleVioletRed
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  DeepSkyBlue
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = false;
extern bool   showInsideBar    = true;
extern bool   showOutsideBar   = false;
extern bool   SignalOnFirstBar = true;

//
//
//
//
//

double val1[];
double val2[];
double val3[];
double val4[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,val1); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"in hi");
   SetIndexBuffer(1,val2); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"in lo");
   SetIndexBuffer(2,val3); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"out hi");
   SetIndexBuffer(3,val4); SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"out lo");
   SetIndexBuffer(4,trend);
   
       //
       //
       //
       //
       //
      
       indicatorFileName = WindowExpertName();
       calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
       returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
      
       //
       //
       //
       //
       //
       
   IndicatorShortName(timeFrameToString(timeFrame)+" Inside Out Bar");
return(0);
}

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//

int deinit(){ return(0);  }

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { val1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     for(i=limit; i>=0; i--) 
     {
        double H1 = iHigh(NULL,0,i+1);
        double L1 =  iLow(NULL,0,i+1);
        double H  = iHigh(NULL,0,i);
        double L  =  iLow(NULL,0,i);
        
        val1[i] = EMPTY_VALUE;
        val2[i] = EMPTY_VALUE;
        val3[i] = EMPTY_VALUE;
        val4[i] = EMPTY_VALUE;
        trend[i] = trend[i+1];
           if (showInsideBar &&  (H1>H)&&(L1<L)) { trend[i] =  1; val1[i] = H; val2[i] = L; }
           if (showOutsideBar && (H1<H)&&(L1>L)) { trend[i] = -1; val3[i] = H; val4[i] = L; }  
    
      }
    manageAlerts();       
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   int shift = -1; if (SignalOnFirstBar) shift=1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
       int x = iBarShift(NULL,timeFrame,Time[i+shift]); 
            trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",4,y);
       if (x!=y)
       {
            val1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",0,y);
            val2[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",1,y);
            val3[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",2,y);
            val4[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",3,y); 
       } 
    }
    manageAlerts();
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]== 1) doAlert(whichBar,"Inside Bar");
         if (trend[whichBar]==-1) doAlert(whichBar,"Outside Bar");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Inside Out Bar ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Inside Out Bar " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Inside Out Bar "),message);
             if (alertsSound)   PlaySound("alert.wav");
      }
}